//
// Tizen Native SDK
// Copyright (c) 2012-2013 Samsung Electronics Co., Ltd.
//
// Licensed under the Flora License, Version 1.1 (the License);
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://floralicense.org/license/
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an AS IS BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

#ifndef _READ_FORM_H_
#define _READ_FORM_H_

#include <FBase.h>
#include <FUi.h>
#include <FNet.h>


class ReadForm
	: public Tizen::Ui::Controls::Form
	, public Tizen::Ui::Controls::IFormBackEventListener
	, public Tizen::Ui::IActionEventListener
	, public Tizen::Ui::Scenes::ISceneEventListener
{

public:
	ReadForm(void);
	virtual ~ReadForm(void);
	bool Initialize(void);
	result SetupData(Tizen::Net::Nfc::NdefMessage* pMsg);
	void UpdateRecord(int increment = 1);
	Tizen::Base::String* GetTextPayloadN(const Tizen::Base::ByteBuffer* data, Tizen::Base::String ndefRecordName);
	virtual result OnInitializing(void);
	virtual result OnTerminating(void);
	virtual void OnSceneActivatedN(const Tizen::Ui::Scenes::SceneId& previousSceneId,
								   const Tizen::Ui::Scenes::SceneId& currentSceneId, Tizen::Base::Collection::IList* pArgs);
	virtual void OnSceneDeactivated(const Tizen::Ui::Scenes::SceneId& currentSceneId,
									const Tizen::Ui::Scenes::SceneId& nextSceneId);
	virtual void OnActionPerformed(const Tizen::Ui::Control& source, int actionId);
	virtual void OnUserEventReceivedN(RequestId requestId, Tizen::Base::Collection::IList* pArgs);
	virtual void OnFormBackRequested(Tizen::Ui::Controls::Form& source);

public:
	static const RequestId REQUEST_UPDATE = 200;

private:
	Tizen::Graphics::Bitmap* __pLeftItemBitmap;
	Tizen::Graphics::Bitmap* __pRightItemBitmap;
	Tizen::Ui::Controls::EditField* __pRecordTypeField;
	Tizen::Ui::Controls::EditField* __pRecordNameField;
	Tizen::Ui::Controls::EditArea* __pPayloadArea;
	Tizen::Net::Nfc::NdefMessage* __pMsg;
	int __totalRecordCount;
	int __currentRecord;
	static const int ID_HEADER_PREV = 401;
	static const int ID_HEADER_NEXT = 402;
};

#endif
